#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#define F_CPU 16000000

void USART0_init()
{
	/*Setez baund rate la 38400.*/
	UBRR0H = 0;
	UBRR0L = 103;

	/*Pornesc transmitatorul.*/
	UCSR0B = (1<<RXEN0);
	UCSR0B |= (1<<RXCIE0);

}

char USART0_receive()
{
	while (!(UCSR0A & (1<<RXC0)));

	return UDR0;
}


/*Setez pinii corespunzatori motoarelor.*/
void initMotor()
{
	DDRA |= (1<<PA1);
	DDRA |= (1<<PA2);
	DDRA |= (1<<PA3);
	DDRA |= (1<<PA4);
	DDRD |= (1<<PD4);
	DDRD |= (1<<PD5);

	PORTA &= ~(1<<PA1);
	PORTA &= ~(1<<PA2);
	PORTA &= ~(1<<PA3);
	PORTA &= ~(1<<PA4);
	PORTD |= (1<<PD4);
	PORTD |= (1<<PD5);

}

void moveForward()
{
	PORTA &= ~(1<<PA1);
	PORTA |= (1<<PA2);

}

void moveBack()
{
	PORTA &= ~(1<<PA2);
	PORTA |= (1<<PA1);
}

void moveLeft()
{
	PORTA &= ~(1<<PA4);
	PORTA |= (1<<PA3);
}

void moveRight()
{
	PORTA &= ~(1<<PA3);
	PORTA |= (1<<PA4);
}


void stopMotor()
{
	PORTA &= ~(1<<PA1);
	PORTA &= ~(1<<PA2);
	PORTA &= ~(1<<PA3);
	PORTA &= ~(1<<PA4);
}

int main()
{
	USART0_init();
	initMotor();

	char command;

	while (1) {
		command = USART0_receive();
		switch(command) {
			case 'F':
				moveForward();
				break;
			case 'B':
				moveBack();
				break;
			case 'L':
				moveLeft();
				break;
			case 'R':
				moveRight();
				break;
			case 'G':
				moveForward();
				moveLeft();
				break;
			case 'I':
				moveForward();
				moveRight();
				break;
			case 'H':
				moveBack();
				moveLeft();
				break;
			case 'J':
				moveBack();
				moveRight();
				break;
			default:
				stopMotor();
				break;
		}
		
	}
}